#!/usr/local/bin/perl -w

use vars qw($opt_f $opt_o);
use Getopt::Std;
use GD;

getopt('fo');

if($opt_f && $opt_o) {
    &image_data($opt_f, $opt_o);
} else {
    &usage();
}


sub image_data {

    my($image, $output) = @_; # input, output file
    my($info, $xval, $yval, $outgif); # locals

    open(IMG, $image) || die("Image error: $!");
    $info = newFromGif GD::Image(IMG);
    close IMG;

    $red = $info->colorAllocate(255, 0, 0); # allocate the color red

    ($xval, $yval) = $info->getBounds(); # get the max bounds

    # Now, iterate through the pixels changing each white pixel to red
    for ($i=0; $i<=$yval; $i++) {
	for($j=0; $j<=$xval; $j++) {
	    $index = $info->getPixel($j, $i);
	    ($r, $g, $b) = $info->rgb($index);
	    if($r == 255 && $g == 255 && $b == 255) {
		$info->setPixel($j, $i, $red);
	    }
	}
    }

    $outgif = $info->gif; # $output is the new gif (with color substitution)

    open(OUT, ">".$output) || die("outfile error: $!");
    print OUT $outgif;
    close(OUT);

}

sub usage {
    print("Usage: $0 -f <infile> -o <outfile>\n");
    exit(0); # failure
}
