#!/usr/local/bin/perl

use strict;
use vars qw($opt_t $opt_o);
use Getopt::Std;
use GD;

getopt('to');

if($opt_t && $opt_o) {
    &make_image($opt_t, $opt_o);
} else {
    &usage();
}

sub make_image {

    my($phrase, $output) = @_;
    my($im, $white, $black, $width, $height);

    ### Compute width, height ratios based on length of phrase and 8x16 font
    $width = length($phrase); # width should represent max phrase length
    $width = $width*8; # width*x spaces the gif correctly for 8x16 (large) font
    $height = 16; # max height is 16 for the 8x16 font

    if($output !~ /\.gif$/) {
	print("WARNING: file does not contain a .gif extension. ",
	      "Adding one.\n");
	$output = $output.".gif";
    }

    open(OUTFILE, ">".$output) || die("output file error: $!");

    print("Opening: $output for writing.\n");

    $im = new GD::Image($width,$height);
    ($white,$black) = 
	(
	 $im->colorAllocate(255, 255, 255),
	 $im->colorAllocate(0, 0, 0)
	 );
    $im->transparent($white);	# white background is transparent
    $im->interlaced(1);

    $im->string(gdLargeFont,0,0,$phrase,$black); # output phrase
    
    print OUTFILE $im->gif;
    close(OUTFILE);
    
}

sub usage {
    print("Usage: $0 -t <phrase> -o <outfile>\n");
    exit(0); # failure
}
