#!/usr/local/bin/perl -w

use vars qw($opt_f $opt_o);
use Getopt::Std;
use GD;

getopt('fo');

if($opt_f && $opt_o) {
    make_image($opt_f, $opt_o);
} else {
    &usage(); # fail-case.  output usage message
}

sub make_image {

    my($infile, $outfile) = @_;
    my($gifdata, $gif);

    open(IN, $infile) || die("XBM error: $!");
    $gif = newFromGif GD::Image(IN) || die;
    close IN;

    $gifdata = $gif->gif;

    open(OUTFILE, ">".$outfile) 
	|| die("output file error: $!");
    print("Opening: $outfile for writing.\n");
    print OUTFILE $gifdata;
    close(OUTFILE);

}


sub usage {
    print("Usage: $0 -f <infile> -o <outfile>\n");
    exit(0); # failure
}
