#!/usr/local/bin/perl -w

use vars qw($opt_f $opt_o);
use Getopt::Std;
use GD;

getopt('fo');

if($opt_f) {
    if($opt_o) {
	&image_data($opt_f, $opt_o);
    } else {
	$opt_o = $opt_f;
	$opt_o =~ s/(.+)\.(.+)/$1_trans\.$2/;
	&image_data($opt_f, $opt_o);
    }
} else {
    &usage();
}


sub image_data {

    my($image, $output) = @_; # input, output file
    my($im, $xval, $yval, $outgif); # locals

    open(IMG, $image) || die("Image error: $!");
    $im = newFromGif GD::Image(IMG);
    close IMG;

    ($xval, $yval) = $im->getBounds(); # get the max bounds

    $white = $im->colorAllocate(255, 255, 255);

    $im->transparent($white);
    $im->interlaced(1);

    $outgif = $im->gif; # $output is the new gif (with color substitution)

    open(OUT, ">".$output) || die("outfile error: $!");
    print OUT $outgif;
    close(OUT);

}

sub usage {
    print("Usage: $0 -f <infile> -o <outfile>\n");
    exit(0); # failure
}
