#!/usr/local/bin/perl -w

use Net::POP3;
use CGI;

# Globals
$pop_host = 'pop.hacker.org';
%all_mesg = ();

# Constructors
$query = new CGI;
$url = $query->self_url;

print $query->header;
$TITLE="Net::POP3 Example";

# PATH_INFO
$path_info = $query->path_info;

# If no path information is provided, then we create 
# a side-by-side frame set
if (!$path_info) {
    &print_frameset;
    exit 0;
}

# If we get here, then we either create the query form
# or we create the response.
&print_html_header;
&print_query if $path_info=~/query/;
&print_response if $path_info=~/response/;
&print_end;


# Create the frameset
sub print_frameset {
    $script_name = $query->script_name;
    print <<EOF;
<html><head><title>$TITLE</title></head>
<frameset rows="40,60">
<frame src="$script_name/query" name="query" NORESIZE>
<frame src="$script_name/response" name="response" NORESIZE>
</frameset>
EOF
    ;
    exit 0;
}

sub print_html_header {
    print $query->start_html($TITLE);
}

sub print_end {
    print qq{<P><hr><A HREF="cgi_docs.html">Go to the documentation</A>};
    print $query->end_html;
}

sub print_query {

    $script_name = $query->script_name;

    print "<H1>Net::POP3 Mail Client</H1>\n";
    
    print $query->startform(-action=>"$script_name/response",
			    -TARGET=>"query");
    
    print "Username: ",$query->textfield(-name => 'username');
    print "Password: ",$query->password_field(-name => 'password'),
    "<P>";
    print $query->submit(-name => 'Login to POP Server');
    print $query->endform;

}

sub print_response {


    $pop = Net::POP3->new($pop_host);

    $result = $pop->login($query->param('username'), 
			  $query->param('password'));

    unless ($query->param) {
	print "<b>No messages Selected.</b>";
	return;
    }

    ($undel) = ($pop->popstat())[0];
    if($undel == 0) {
	print("<B>No messages left on server.</B>\n");
	$pop->quit();
	exit(1);
    }

    if($query->param('delete')) {

	print("<H1>Deleted message: ",$query->param('mesg'),"</H1>\n");
	$pop->delete($query->param('delete')) || redir_err($!);

    }
    

    if($query->param('mesg')) {

	print("<H1>Reading message: ",$query->param('mesg'),"</H1>\n");

	$m_num = $query->param('mesg');
	(*message) = $pop->get($m_num);

	for($i=0; $i<=$#message; $i++) {
	    $message[$i] =~ s/\n/<BR>\n/g;
	    print $message[$i];	
	}

    }


    if($query->param('username') && $query->param('password')
       && $query->param('mesg') eq '') {	

	print "<H1>Logged into: $pop_host</H1>\n";

	if($result > 0) {

	    *all_mesg = $pop->list;
	    foreach $key (keys %all_mesg) {
		
		(*message) = $pop->get($key);
		for($i=0; $i<=$#message; $i++) {
		    $from = $message[$i]; # need this for reply
		    if($from =~ /From:/) {
			$from =~ s/(.+)<(.*?)>/$2/g;
			chop($from);

			$headers{$key} = "<A HREF=\"$url\&mesg=$key\"".
			    "TARGET=\"response\">".$key."</A>. <B>From</B>:".
				" <A HREF=\"mailto:$from\">".$from."</A>";

		    }
		    
		    if($message[$i] =~ /Subject:/) {
			$subj = $message[$i];
			$subj =~ s/Subject: (.+)/<I>$1<\/I>/g;
			chop($subj);
			$headers{$key} = 
			    $headers{$key}."\t"."<B>Subject</B>: ".
				$subj."<A HREF=\"$url\&delete=$key\"> ".
				    "Delete Message</A><BR>\n";
		    }
		    
		}
	    }   
	    
	    foreach $header (keys %headers) {
		print $headers{$header};
	    }

	} elsif($result == 0) {
	    print("<B>No new messages on server.</B>\n");
	    exit(1);
	} else {
	    print("<B>Login Failed</B>.\n");
	}

    } 

    $pop->quit();

}

sub redir_err {
    
    my($error) = @_;
    print("Error: $error");
    exit(0); # error failure
}
