#!/usr/local/bin/perl -w

# Script: newsrc_2.pl

$newshost = 'news.hacker.org'; # nntp host
$total = 0; # initialize total to zero

use News::NNTPClient;
$c = new News::NNTPClient($newshost);

use News::Newsrc;
$newsrc = new News::Newsrc;

$newsrc->load(); # default .newsrc
@groups = $newsrc->sub_groups(); ### our subscribed groups

foreach $group (@groups) {

    @articles = $newsrc->marked_articles($group); # check each group
                                                  # containing marked articles
    $total = $#articles + 1; # total articles (array elements +1)
    $last = ($c->group($group))[1]; # number of last article in group
    $current = ($last - $total); # new articles derived from last - total

    if ($current <= 0) { # no new articles
	print("Newsgroup $group has no new articles.\n");
    } elsif($current == 1) { # new article, but watch the plural in response
	print "Newsgroup $group: has $current new article.\n";
    } else { # more than one new article
	print "Newsgroup $group: has $current new articles.\n";
    }

}

