#!/usr/local/bin/perl

use CGI;

$query = new CGI;

print $query->header;
print $query->start_html("NNTP WWW - A World Wide Web-based Usenet Reader");
print "<H2>NNTP WWW - A World Wide Web-based Usenet Reader</H2>\n";
&print_prompt($query);
&output_hash($query);
&print_tail;
&show_active_ng();
print $query->end_html;


sub print_prompt {
    my($query) = @_;
    
    print $query->startform;
        
    print "<P><EM>Available Newsgroups</EM>  ";
    print $query->scrolling_list(
				 -name=>'newsgroups',
				 -values=>[&show_active_ng()],
				 -size=>3,
				 -multiple=>'');
    
    if($query->param('newsgroups')) {
	print "<P><EM>Subjects for ", $query->param('newsgroups')," </EM>  ";
	&show_subjects_from_active($query->param('newsgroups'));
    }

    if($query->param('subjects')) {
	print "<P><EM>Reading Article ", $query->param('subjects'),".</EM>  ";
	&show_article_as_html($query->param('subjects'), 
			      $query->param('newsgroups'));
    }

    print "<P>",$query->reset;
    print $query->submit('Action','Send News Request');
    print $query->endform;
    print "<HR>\n";
}


sub output_hash {
    my($query) = @_;
    my(@values,$key);

    print "<H2>Here are the current settings in this form</H2>";

    foreach $key ($query->param) {
	print "<STRONG>$key</STRONG> -> ";
	@values = $query->param($key);
	print join(", ",@values),"<BR>\n";
    }
}


sub print_tail {

    print <<END;
    <HR>
	<ADDRESS>Nathan V. Patwardhan</ADDRESS><BR>
            <A HREF="http://www.ora.com">Home Page</A>
END

}


### Helper functions

sub show_active_ng {

    use News::NNTPClient;
    $newshost = 'news.hacker.org';
    
    $c = new News::NNTPClient($newshost);
    @newsgroups = $c->list("active.times"),"\n";
    foreach $newsgroup (@newsgroups) {
	# remove unwanted newsgroup information
	($groupname, $vol, $active, $owner) = split(/\s/, $newsgroup);
	push(@groups, $groupname);
    }

    return(sort(@groups)); ### return active newsgroups
}


sub show_subjects_from_active {

    my($newsgroup) = @_; ### pass in newsgroup

    use News::NNTPClient;
    $newshost = 'news.hacker.org';
    
    $c = new News::NNTPClient($newshost);

    $sel_mult = "<SELECT NAME=\"subjects\" SIZE=6>\n";
    push(@articles, $sel_mult);

    for ($c->xover($c->group($newsgroup))) {
	($article, $subject) = split /\t/;
	if($subject =~ /Re:/) {
	    $subject = "<OPTION VALUE=\"$article\">".$subject."\n";
	} else {
	    $subject = "<OPTION VALUE=\"$article\">"."Re: ".$subject."\n";
	}	    
	push(@articles, $subject);	
    }

    $sel_mult = "</SELECT>\n";
    push(@articles, $sel_mult);

    print(@articles,"\n");

}


sub show_article_as_html {

    my($article_number, $newsgroup) = @_; # pass in article number

    use News::NNTPClient;
    $newshost = 'news.hacker.org';
    
    $c = new News::NNTPClient($newshost);

    $c->group($newsgroup);
    @lines = $c->article($article_number);

    print("<HR NOSHADE>\n");

    foreach $line (@lines) {
	$line =~ s/\n/<BR>\n/g;
	print $line;
    }

}
