#!/usr/local/bin/perl

use CGI;

$query = new CGI;

print $query->header;

$path_info = $query->path_info;

if (!$path_info) {
    &print_frameset;
    exit 0;
}

&print_html_header;
&print_prompt($query) if $path_info=~/query/;
&print_response($query) if $path_info=~/lower/;
&print_end;

# Create the frameset
sub print_frameset {
    $script_name = $query->script_name;
    print <<EOF;
<html><head><title>NNTP-WWW: A WWW-based Usenet Reader</title></head>
<frameset rows="40,60">
<frame src="$script_name/query" name="query" noresize>
<frame src="$script_name/lower" name="lower" noresize>
</frameset>
EOF
    ;
    exit 0;
}


sub print_html_header {
    print 
	$query->start_html("NNTP WWW - A World Wide Web-based Usenet Reader");
}


sub print_end {

    print <<END;
    <HR NOSHADE>
	<ADDRESS>Nathan V. Patwardhan</ADDRESS><BR>
           [<A HREF="http://www.hacker.org/cgi-bin/nntp_www2.pl" TARGET="_top">Return Home</A>]
           <BR>
           [<A HREF="http://www.hacker.org/cgi-bin/nntp_www2.pl?new_group=yes" TARGET="_top">Choose New Newsgroup</A>]
END
    print $query->end_html;
}


sub print_prompt {

    my($query) = @_;

    $script_name = $query->script_name;
    
    print $query->startform(-action=>"$script_name/lower",
			    -TARGET=>"query");
        
    print "<P><EM>Available Newsgroups</EM>  ";
    print $query->scrolling_list(
				 -name=>'newsgroups',
				 -values=>[&show_active_ng()],
				 -size=>3,
				 -multiple=>'');
    
    print "<P>",$query->reset;
    print $query->submit('Send News Request');
    print $query->endform;

}


sub print_response {

    my($query) = @_;
    my(@values,$key);

    $script_name = $query->script_name;

    if ($query->param('newsgroups') eq '' && $query->param('subjects') eq '') {
	print "<H2>Current Settings</H2>";
	print "<b>No articles selected.</b>";
    }
	

    if($query->param('new_group')) {
	&print_prompt($query);
	return;
    }

    if($query->param('subjects')) {
	print "<P><EM>Reading Article ", $query->param('subjects'),".</EM>  ";
	
	&show_article_as_html($query->param('subjects'), 
			      $query->param('newsgroups'));
	$query->delete('newsgroups');
	
	return;
    }
    
    if($query->param('newsgroups')) {
	print $query->startform(-action=>"$script_name/lower",
				-TARGET=>"lower");
	print "<P><EM>Subjects for ", $query->param('newsgroups')," </EM>  ";
	&show_subjects_from_active($query->param('newsgroups'));
	print "<P>",$query->reset;
	print $query->hidden(-name=>'newsgroups',
			     -default=>[$query->param('newsgroups')]);
	print $query->submit('Select Article');
	print $query->endform;
	
	return;
    }

}



### Helper functions

sub show_active_ng {

    use News::NNTPClient;
    $newshost = 'news.hacker.org';
    
    $c = new News::NNTPClient($newshost);
    @newsgroups = $c->list("active.times"),"\n";
    foreach (@newsgroups) {
	# remove unwanted newsgroup information
	($groupname, $vol, $active, $owner) = split(/\s/, $_);
	undef $vol; undef $active; undef $owner; # reclaim

	($last) = ($c->group($groupname))[1];

	if($last > 0) { # don't show empty newsgroups
	    push(@groups, $groupname);
	}
    }

    return(sort(@groups)); ### return active newsgroups
}


sub show_subjects_from_active {

    my($newsgroup) = @_; ### pass in newsgroup

    use News::NNTPClient;
    $newshost = 'news.hacker.org';
    
    $c = new News::NNTPClient($newshost);

    $sel_mult = "<SELECT NAME=\"subjects\" SIZE=6>\n";
    push(@articles, $sel_mult);

    for ($c->xover($c->group($newsgroup))) {
	($article, $subject) = split /\t/;
	if($subject =~ /Re:/) {
	    $subject = "<OPTION VALUE=\"$article\">".$subject."\n";
	} else {
	    $subject = "<OPTION VALUE=\"$article\">"."Re: ".$subject."\n";
	}	    
	push(@articles, $subject);	
    }

    $sel_mult = "</SELECT>\n";
    push(@articles, $sel_mult);

    print(@articles,"\n");

}


sub show_article_as_html {

    my($article_number, $newsgroup) = @_; # pass in article number

    use News::NNTPClient;
    $newshost = 'news.hacker.org';
    
    $c = new News::NNTPClient($newshost);

    $c->group($newsgroup);
    @lines = $c->article($article_number);

    print("<HR NOSHADE>\n");

    foreach $line (@lines) {
	$line =~ s/\n/<BR>\n/g;
	print $line;
    }

}
