#!/usr/local/bin/perl -w


use Getopt::Long;
use vars qw($file $rev $temp);
use strict;

GetOptions('f:s', \$file, 'rev:s', \$rev);

if($file && $rev) {
    &usage();
} elsif($file) {
    open(FILE, $file);
    while(<FILE>) { print; }
    close(FILE);
} elsif($rev) {
    open(FILE, $rev);
    while($temp = reverse(<FILE>)) { print $temp; }
    close(FILE);
} else {
    &usage();
}

sub usage {
    print("$0 -f infile --OR-- $0 -rev infile\n");
    exit(0);
}
