#!/usr/local/bin/perl -w

use strict;
use Tk; 

my($main, $top, $bottom);
my($label_text, $name_entry, $left_bt, $clr_bt, $right_bt);

$main = new MainWindow;

### TOP HALF ###

### Widget label ###
$top = $main->Frame(); # create a new container for the top half

# Put label to the left of the text entry.
$label_text = $top->Label(-text => 'Enter your name: ');
$label_text->pack(-side => 'left');

# Place text entry after the label
$name_entry = $top->Entry(-relief => 'sunken', borderwidth => 2);
$name_entry->pack(-side => 'left');

$top->pack(-fill => 'both', 
	   -expand => 1); # show the top half of the widget

### BOTTOM HALF ###

$bottom = $main->Frame(); # create a new container for the bottom half

### Left Button ###
$left_bt = $bottom->Button(-text => 'Process Entry',
			   -command => sub{&enter_name});
$left_bt->pack(-side => 'left', fill => 'x', -expand => 1);

### Middle Button ###
$clr_bt = $bottom->Button(-text => 'Clear Entry',
			   -command => sub{&clear_form});
$clr_bt->pack(-side => 'left', fill => 'x', -expand => 1);

### Right Button ###
$right_bt = $bottom->Button(-text => 'Quit',
			    -command => sub{exit});
$right_bt->pack(-side => 'left', fill => 'x', -expand => 1);

$bottom->pack(-side => 'left', 
	      -fill => 'both', 
	      -expand => 1); # show the bottom half of the widget

# MAIN EVENT HERE
MainLoop;


# Helper functions

sub enter_name {
    
    my($name);
    
    $name = $name_entry->get;
    if($name) {
	print $name,"\n";
    } else {
	print "Nothing entered.  Try again.\n";
    }

}

sub clear_form {

    $name_entry->delete(0, 'end');
    print "Cleared entry area.\n";
}
