#!/usr/local/bin/perl -w

require 5.002;
use English;

use Tk;
use Tk::Dialog;
use Net::FTP;

### Phase 0: create the front end.

$top = MainWindow->new;
$top->Label(-text => 'Perl/Tk FTP Client')->pack(-fill => 'both', -expand => 1);
$tl = $top->Frame();

$local_list = $tl->Frame(-relief => 'raised', -borderwidth => '2');
$l1 = $local_list->Label(-text => 'Local Filesystem');
$l1->pack(-fill => 'both', -expand => 1);
$local_list->pack(-fill => 'both', -expand => 1, -side => 'left');

# LOCAL FILESYSTEM - Left Side
$left_top = $local_list->Frame();
my $localdir = $left_top->Listbox(
    -exportselection => 0,
    -relief => 'sunken', 
    -width => 30, 
    -height => 10, 
    -setgrid => 'yes',
    -relief => 'sunken',
    -borderwidth => '2'
);
my $scroll2 = $left_top->Scrollbar(-command => ['yview', $localdir],
				   -relief => 'sunken',
				   -borderwidth => '2',
				   );
$localdir->configure(-yscrollcommand => ['set', $scroll2]);

# Bind left button to double-click local directory
$localdir -> bind('<Double-1>' => sub{change_local_directory()});

$scroll2->pack(-side => 'right', -fill => 'y');

$localdir->pack(-side => 'left',
		-fill => 'both', 
		-expand => 1);

foreach (1..10) {
    $localdir->insert('end', "");
}

$left_top->pack(-side => 'top');

my $ld_button = $local_list->Button(-text => 'Open Local Filesystem',
				    -relief => 'raised',
				   -borderwidth => '2',
				    -command => sub {open_local_filesystem()})->pack(-fill => 'both', -expand => 1);
my $ld_button = $local_list->Button(-text => 'Close Local Filesystem',
				    -relief => 'raised',
				   -borderwidth => '2',
				    -command => sub {close_local_filesystem()})->pack(-fill => 'both', -expand => 1);

$left_bottom = $local_list->Frame();
my $localfile = $left_bottom->Listbox(
    -selectmode => 'multiple',
    -exportselection => 0,
    -relief => 'sunken', 
    -width => 30, 
    -height => 10, 
    -setgrid => 'yes',
    -relief => 'sunken',
    -borderwidth => '2'
);
my $scroll2 = $left_bottom->Scrollbar(-command => ['yview', $localfile],
				      -relief => 'sunken',
				      -borderwidth => '2',
				      );
$localfile->configure(-yscrollcommand => ['set', $scroll2]);
$scroll2->pack(-side => 'right', -fill => 'y');

$localfile->pack(-side => 'left',
		-fill => 'both', 
		-expand => 1);

foreach (1..10) {
    $localfile->insert('end', "");
}

$left_bottom->pack(-side => 'bottom');


# BUTTONS - packed left of remote filesystem (north down)
$buttons = $tl->Frame();
my $button_left = $buttons->Button(-text => '<--', -relief => 'raised',
				   -borderwidth => '2', 
				   -command => sub{download_file()},
				   -anchor => 'n')->pack(-fill => 'both', -expand => 1);
my $button_quit = $buttons->Button(-text => 'Quit', -relief => 'raised',
				   -borderwidth => '2',
				   -command => sub{exit})->pack(-fill => 'both', -expand => 1);
my $button_right = $buttons->Button(-text => '-->', -relief => 'raised',
				   -borderwidth => '2',
				    -command => sub{upload_file()})->pack(-fill => 'both', -expand => 1);
$buttons->pack(-fill => 'both', -expand => 1, -side => 'left');


# REMOTE FILESYSTEM - Right Side
$remote_list = $tl->Frame(-relief => 'raised', -borderwidth => '2');
$l2 = $remote_list->Label(-text => 'Remote FileSystem');
$l2->pack(-fill => 'both', -expand => 1);
$remote_list->pack(-fill => 'both', -expand => 1, -side => 'right');

$tl->pack(-fill => 'both', -expand => 1);

$right_top = $remote_list->Frame();
my $remotedir = $right_top->Listbox(
    -exportselection => 0,
    -relief => 'sunken', 
    -width => 30, 
    -height => 10, 
    -setgrid => 'yes',
    -relief => 'sunken',
    -borderwidth => '2'
);
my $scroll2 = $right_top->Scrollbar(-command => ['yview', $remotedir],
				    -relief => 'sunken',
				    -borderwidth => '2',
				    );
$remotedir->configure(-yscrollcommand => ['set', $scroll2]);
$scroll2->pack(-fill => 'both', -expand => 1,
	       -side => 'right', -fill => 'y');

# Bind left button to double-click local directory
$remotedir -> bind('<Double-1>' => sub{open_ftp_connection('',
							   '',
							   '',
							   'cwd')});

$remotedir->pack(-side => 'right',
		-fill => 'both', 
		-expand => 1);
$right_top->pack(-fill => 'both', -expand => 1, -side => 'top');

$ld_button = $remote_list->Button(-text => 'Open Remote Filesystem',
				  -relief => 'raised',
				   -borderwidth => '2',
				  -command => sub{auth_info()})->pack(-fill => 'both', -expand => 1);
$ld_button = $remote_list->Button(-text => 'Close Remote Filesystem',
				  -relief => 'raised',
				   -borderwidth => '2',
				  -command => sub{open_ftp_connection('',
								      '',
								      '',
								      'quit')
						  })->pack(-fill => 'both', 
							   -expand => 1);

$right_bottom = $remote_list->Frame();
my $remotefile = $right_bottom->Listbox(
    -selectmode => 'multiple',
    -exportselection => 0,
    -relief => 'sunken', 
    -width => 30, 
    -height => 10, 
    -setgrid => 'yes',
    -relief => 'sunken',
    -borderwidth => '2'
);
my $scroll2 = $right_bottom->Scrollbar(-command => ['yview', $remotefile],
				       -relief => 'sunken',
				       -borderwidth => '2',
				       );
$remotefile->configure(-yscrollcommand => ['set', $scroll2]);
$scroll2->pack(-fill => 'both', -expand => 1, -side => 'right', -fill => 'y');

$remotefile->pack(-fill => 'both', 
		-expand => 1);
$right_bottom->pack(-fill => 'both', -expand => 1, -side => 'bottom');


# THE MAIN EVENT
MainLoop;

# Toplevel Windows

sub auth_info {

    $pane = $top->Toplevel(-title => 'Login to FTP Server');
    $auth_form = $pane->Frame;
    $auth_form->pack;

    $tophalf = $auth_form->Frame();

    $first = $tophalf->Frame(-relief => 'raised', -borderwidth => '2');
    $first->Label(-text => 'Username: ')->pack(-side => 'left');
    $username = $first->Entry(-width => 30, 
				 -relief => 'sunken')->pack(-side => 'left');
    $first->pack(-side => 'left');

    $second = $tophalf->Frame(-relief => 'raised', -borderwidth => '2');
    $second->Label(-text => 'Password: ')->pack(-side => 'left');
    $password = $second->Entry(-width => 30, -relief => 'sunken', 
				  -show => '*')->pack(-side => 'left');
    $second->pack(-side => 'left');

    $third = $tophalf->Frame(-relief => 'raised', -borderwidth => '2');
    $third->Label(-text => 'FTP Host: ')->pack(-side => 'left');
    $ftp_host = $third->Entry(-width => 30, 
			       -relief => 'sunken')->pack(-side => 'left');
    $third->pack(-side => 'right');

    $tophalf->pack(-side => 'top');

    $bottomhalf = $auth_form->Frame();
    $button_1 = $bottomhalf->Button(-text => 'Login',
				    -command => sub {open_ftp_connection($username, $password, $ftp_host, '')});
    $button_1->pack(-side => 'left');
    $button_2 = $bottomhalf->Button(-text => 'Clear Entries',
				    -command => sub {clear_auth_form()});
    $button_2->pack(-side => 'left');

    $button_3 = $bottomhalf->Button(-text => 'Exit Authorization',
				    -command => [$pane => 'withdraw'],
				    -anchor => 'center');
    $button_3->pack(-side => 'left');
    $button_4 = $bottomhalf->Button(-text => 'Quit Program',
				    -command => sub {exit});
    $button_4->pack(-side => 'left');
    $bottomhalf->pack(-side => 'bottom');

}


# Helper functions

sub clear_auth_form {

    $username->delete(0, 'end');
    $password->delete(0, 'end');

}


sub open_local_filesystem {

    # first, cleanup
    $localdir->delete(0, 'end');
    $localfile->delete(0, 'end');

    foreach (file_type($ENV{'HOME'},'dir')) {
	$localdir->insert('end', $_);
    }

    foreach (file_type($ENV{'HOME'},'file')) {
	$localfile->insert('end', $_);
    }

}

sub change_local_directory {

    $prevdir = '' unless $prevdir;

    @local_dir = $localdir->curselection;
    for(@local_dir) { $newdir = $localdir->get($_);};
    chdir($newdir);

    if($prevdir eq '') {
	$todir = $ENV{'HOME'}."/".$newdir."/";
    } else {
	    $prevdir .= $newdir."/";
	    $todir = $prevdir;
    }
    $prevdir = $todir;

    # Reset ../ if current dir is the same as ../../foo/../../bar
    if((stat($todir))[1] eq (stat($ENV{'HOME'}))[1]) {
	$todir = $ENV{'HOME'};
	$newdir = '';
	$prevdir = '';
    }

    # first, cleanup
    $localdir->delete(0, 'end');
    $localfile->delete(0, 'end');

    # then, open it up
    foreach (file_type($todir,'dir')) {
	$localdir->insert('end', $_);
    }

    foreach (file_type($todir,'file')) {
	$localfile->insert('end', $_);
    }

}

sub close_local_filesystem {

    # clear out both panes
    $localdir->delete(0, 'end');
    $localfile->delete(0, 'end');

}


sub open_ftp_connection {

    my($user, $pass, $host, $cmd) = @_;
    my($login, $password, $ftp_host);

    if($cmd eq '' && $user ne '' && $pass ne '' && $host ne '') { 
        # we're not quitting
	# first, cleanup
	$remotedir->delete(0, 'end');
	$remotefile->delete(0, 'end');

	$login = $user->get();
	$password = $pass->get();
	$ftp_host = $host->get();

	$ftp = Net::FTP->new($ftp_host, Debug=>2000);
	#$ftp = Net::FTP->new($ftp_host);
	$ftp->login($login, $password);
	#$ftp->cwd("/");
	
	@entries = $ftp->dir('-al');
	foreach (@entries) {
	    (@foo) = split(/\s+/, $_);
	    next if $foo[8] eq '';
	    if($foo[0] =~ /d(.+)/ || $foo[0] =~ /l(.+)/) {
		print "DIR: ",$foo[8],"\n";
		$remotedir->insert('end', $foo[8]);
	    } else {
		print "File: ",$foo[8],"\n";
		$remotefile->insert('end', $foo[8]);
	    }
	} 
    } elsif($cmd eq 'quit' && $user eq '' 
	   && $pass eq '' && $host eq '') { 
	# send (ftp) quit
	#$ftp->get("that.file");
	$ftp->quit;
    } elsif ($cmd eq 'cwd' && $user eq '' && $pass eq '' && $host eq '') {

	@dir = $remotedir->curselection;
	for(@dir) { print $remotedir->get($_),"\n";
		    $ftp->cwd($remotedir->get($_)); }

	$remotedir->delete(0, 'end');
	$remotefile->delete(0, 'end');
	
	@entries = $ftp->dir('-al');
	foreach (@entries) {
	    (@foo) = split(/\s+/, $_);
	    next if $foo[8] eq '';
	    if($foo[0] =~ /d(.+)/ || $foo[0] =~ /l(.+)/) {
		print "DIR: ",$foo[8],"\n";
		$remotedir->insert('end', $foo[8]);
	    } else {
		print "File: ",$foo[8],"\n";
		$remotefile->insert('end', $foo[8]);
	    }
	} 
    } else {
	print("Nothing matches.\nBailing out...\n");
	$ftp->quit;
    }

}

sub download_file {

    my(@files);

    @files = $remotefile->curselection;    
    @tolocal = $localdir->curselection;

    for(@tolocal) { $todir = $localdir->get($_); }

    for(@files) { 
	print "Getting --> ",$remotefile->get($_),"\n";
	$ftp->get($remotefile->get($_), $todir."/".$remotefile->get($_));
    }

}


sub upload_file {

    my(@files);

    @files = $localfile->curselection;    
    for(@files) { 
	print "Putting --> ",$localfile->get($_),"\n";
	$ftp->put($localfile->get($_));
    }

}


sub close_remote_fs {

    # clear out both panes
    $remotedir->delete(0, 'end');
    $remotefile->delete(0, 'end');

}


sub file_type {

    my($dirname, $type) = @_;
    my (@files, @dirs);

    chdir($dirname);

    opendir(DIR, $dirname) || die("dir open error: $!");
    while($entry = readdir(DIR)) {
	if(-f $dirname."/".$entry) {
	    push(@files, $entry);
	} else {
	    push(@dirs, $entry);
	}
    }
    closedir(DIR);

    if($type eq 'file') {
	return(@files);
    } elsif($type eq 'dir') {
	return(@dirs);
    }

}
