#!/usr/local/bin/perl -w

use strict;
use Getopt::Long;

use vars qw($start $kill_pid $server_prog $pidfile $pid);

GetOptions('start', \$start, 'kill', \$kill_pid,
	   'help', \&usage);

# Program and pid file declarations
$server_prog = 'TestServer.pl';
$pidfile = 'logs/perlwww.pid';

# avoid case like $0 -start -kill (which is impossible)
# give error
usage() if $start && $kill_pid;

# okay, let's start the server by exec()'ing the script
if($start) {
    print("Starting $server_prog, process: $$.\n");
    exec($server_prog);
}

# okay, let's halt the server by grabbing the pid from the pid-file
# and kill -9'ing it
if($kill_pid) {
    open(IN, $pidfile) or die("open error: $!");
    chop($pid = <IN>);
    close(IN);
    print("Killing process, pid: $pid.\n");
    kill(9, $pid) or die("can't kill process: $!");
}

sub usage {
    print("StartServer.pl -start (starts server)\n");
    print("StartServer.pl -kill (stops server)\n");
    exit(0);
}

