#!/usr/local/bin/perl -w

use IO::File;
use IPC::Open2;
use HTTP::Daemon;
use HTTP::Status;
use HTTP::Date;
use IO::File;
use POSIX;
use Net::Domain qw(hostfqdn);

$ServerRoot = '/home/nvp/ORA/PRK/Chapters/WWW/WebAdmin/Server/';
$ServerName = 'www.hacker.org';
$ServerPort = 8080;

$http_daemon = new HTTP::Daemon
    LocalAddr => $ServerName,
    LocalPort => $ServerPort;

$http_resp = new HTTP::Response;

print "Please contact me at: <URL:", $http_daemon->url, ">\n";

### BEGIN MAIN HERE
run();

sub init {

    my $pid = fork();
    exit(0) if $pid;
    die "Unable to fork: $!" unless defined($pid);

    open(PIDFILE, ">".$ServerRoot."logs/perlwww.pid");
    flock(PIDFILE, 2);
    print PIDFILE $$."\n";
    close(PIDFILE);

}

sub run {

    init();

    for(;;) {

	open (STDIN, "</dev/null") || die "Could not redir STDIN\n";
	open (STDOUT, ">/dev/null") || die "Could not redir STDOUT\n";

	# Clear out your normal environment before proceeding.
	# Despite the fact that it's largely irrelevant to what
	# your server will need to do, it's got some stuff in it
	# that you don't want to world to know about.  :-)
	foreach(keys %ENV) { delete $ENV{$_}; }

	# Define an environment based on the CGI spec.  If you don't
	# understand this environment, see: http://hoohoo.ncsa.uiuc.edu
	$ENV{'HOSTNAME'} = hostfqdn();
	$ENV{'TERM'} = "dumb";
	$ENV{'GATEWAY_INTERFACE'} = 'CGI/1.1';
	$ENV{'SERVER_SOFTWARE'} = 'TestServer/0.01';
	$ENV{'SERVER_PROTOCOL'} = 'HTTP/1.1';
	$ENV{'SERVER_PORT'} = $ServerPort;

	$connect = $http_daemon->accept;
	$connect->autoflush(1);

	$req = $connect->get_request;

	$ENV{'REMOTE_ADDR'} = $connect->peerhost();
	$ENV{'REMOTE_HOST'} = gethostbyaddr($connect->sockaddr(), AF_INET);

	if($req->method ne 'GET') {
	    print("Sorry, method not implemented yet...\n");
	    exit(0); # failure
	} else {
	    if($req->url->path =~ /\/cgi-bin\//) {

#	    print $req->url()->epath()."\n";
#	    print $req->url()->equery()."\n";

		$cgi_prog = substr($ServerRoot, 0, length($ServerRoot)-1).
		    $req->url()->epath();

#		$http_resp->push_header('Server' => $ENV{'SERVER_SOFTWARE'});

		$cgi_get_proc = new IO::File("$cgi_prog |");
		while (<$cgi_get_proc>)
		{
		    tr/\r\n//d;
		    last unless length;
		    if (/^([^:]+):\s*([^\r\n]+)$/) { 
			$http_resp->header("$1" => "$2"); 
		    } else { 
			return $connect->send_error(RC_INTERNAL_SERVER_ERROR); 
		    }
		}
		
		while(<$cgi_get_proc>) {
		    $http_resp->add_content($_);
		}

		$connect->send_response($http_resp);

	    } else {
		$file = $ServerRoot."htdocs".$req->url->epath();
		$file .= 'index.html' if $req->url->path eq '/';
		$connect->send_file_response($file);
	    }
	}
	$connect->close();
    }

}

